//
//  Miner.h
//  MobeleaderMiner
//
//  Created by Mobeleader on 2/1/18.
//  Copyright © 2018 Beleader Internet Marketing S.L. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

//Protocol to know what is happening on the library
@protocol MinerDelegate
@optional

//Optional function to implement something when the library is started and is going to fetch advertisements
-(void)onLibStart;

//Optional function to implement something when the library starts the minig process
-(void)onStartMining;

//Optional function to implement something when the library stops the minig process
-(void)onStopMinig;

//Optional function that returns the total number of hashes mined
-(void)onTotalHashesReceived:(NSString *)hashes;

//Optional function that returns the number of hashes verified
-(void)onVerifiedHashesReceived:(NSString *)hashes;

//Optional function that returns the hashes per second rate
-(void)onHashRateReceived:(NSString *)hashes;

//Optional function to show the errors
//The error variable contains the explanation of the error
-(void)onError:(NSString *)error;

@end

//Miner Object
@interface Miner : NSObject

//Optional value for delegate sps.
@property(nonatomic,assign)id delegate;

//The function to add requiered value created in mobeleader website.
- (void) setAppHash: (NSString *)appHash;

//The function to add the rootViewController
- (void)setRootViewController:(UIViewController * )rootViewController;

//The function to start mining
- (void)start;

//The function to start mining
- (void)stop;

//The function to get the current version of Miner
- (NSString*) getVersion;

//The function to get the total number of hashes mined
- (void) getTotalHashes;

//The function to get the number of hashes verified
- (void) getAcceptedHashes;

//The function to get the hashes per second rate
- (void) getHashesPerSecond;

+(Miner*)shared;

@end
